module bcd(out,co,a,b,ci,s);

input [7:0]a,b;
input ci,s;
output [7:0]out;
output co;
wire [7:0]t1,t2;
wire w1,w2,w3,w4;
wire v1,v2,v3;

fas4 f11 ( t1[3:0] , w1 , {s,1'b0,s,1'b0} , b[3:0] , s ),
		 f21 ( t1[7:4] , v1 , {s,1'b0,1'b0,s} , b[7:4] , s );

fa4 f12 ( t2[3:0] , w2 , t1[3:0] , a[3:0] , ci),
		f13 ( out[3:0] , w4 , t2[3:0] , {1'b0,w3,w3,1'b0} , 1'b0),
	  f22 ( t2[7:4] , v2 , t1[7:4] , a[7:4] , w3),
		f23 ( out[7:4] , co , t2[7:4] , {1'b0,v3,v3,1'b0} , 1'b0);

assign w3= (t2[3]&t2[2]) | (t2[3]&t2[1]) | w2;
assign v3= (t2[7]&t2[6]) | (t2[7]&t2[5]) | v2;

endmodule